#pragma once

#include "CUdpSocket.h"
#include "CSessionManager.h"
#include "defines.h"

class CMyServer : public CUdpSocket, public CSessionManager
{
public:
	CMyServer(int clis = 5, int alive = 16) : CSessionManager(clis,alive) {}

	int SendPacketTo(SOCKADDR_IN* sa, int sid, int msg, void *data, int datalen)
	{
		PACKET pkt = {PKTHDRCODE};
		pkt.hdr.msg = msg;
		pkt.hdr.sid = sid;
		CopyMemory(pkt.data, data, min(sizeof(pkt.data),datalen));
		return SendTo(&pkt, datalen + sizeof(pkt.hdr) , sa);
	}

	int SendPacketTo(int id, int msg, void *data, int datalen)
	{
		SOCKADDR_IN sa;
		if(GetSessionSa(&sa, id)) return -1;
		return SendPacketTo(&sa, GetSessionSid(id) , msg, data, datalen);
	}

	int BroadCastPacket( int msg, void *data, int datalen)
	{
		int maxsessions = m_maxsessions;
		for(int i=0; i<maxsessions; ++i)
			SendPacketTo(i, msg, data, datalen);
		return 0;
	}
	int RecvPacketFrom(PACKET *pkt, SOCKADDR_IN *from)
	{
		int r = RecvFrom(pkt, sizeof(PACKET), from);
		if( r < 0) return -1;
		if(pkt->hdr.pkthdrcode != PKTHDRCODE) return -2;
		return r;
	}
};

class CMyClient: public CUdpSocket, public CSessionManager
{

public:
	CMyClient(int alive = 5) : CSessionManager(1, alive) {}
	int Close()
	{
		CUdpSocket::Close();
		CSessionManager::DelSession();
		return 0;
	}

	int SendPakcet(int msg, void *data, int datalen)
	{
		PACKET pkt = {PKTHDRCODE};
		pkt.hdr.msg = msg;
		pkt.hdr.sid = GetSessionSid();
		CopyMemory(pkt.data, data, min(sizeof(pkt.data),datalen));
		SOCKADDR_IN sa;
		if(GetSessionSa(&sa)) return -1;
		return SendTo(&pkt, datalen + sizeof(pkt.hdr) , &sa);
	}

	int RecvPacket(PACKET *pkt){
		SOCKADDR_IN sa;
		int recvsz = RecvFrom(pkt, sizeof(PACKET) , &sa);
		if(recvsz == SOCKET_ERROR) return -1;

		if(pkt->hdr.pkthdrcode != PKTHDRCODE) return -2;
		if(GetSessionId(&sa, pkt->hdr.sid) !=0) return -2;

		return recvsz;
	}

};