
#include "stdafx.h"
#include "CSessionManager.h"

CSessionManager::CSessionManager(int MaxSessions, int AliveTime)
: m_maxsessions(MaxSessions), m_maxalive(AliveTime)
{
	m_session = new SESSIONINFO[MaxSessions];
	ZeroMemory(m_session, sizeof(SESSIONINFO) * MaxSessions);
}

CSessionManager::~CSessionManager()
{
	delete [] m_session;
}

bool CSessionManager::IsVaildSession(int id)
{
	if( (unsigned)id >= (unsigned) m_maxsessions) return false;
	if( m_session[id].alive ) return true;
	return false;
}

int CSessionManager::GetSessionId(const SOCKADDR_IN* sa, int sid)
{
	int maxsessions = m_maxsessions;
	for(int i=0; i<maxsessions; ++i)
	{
		if(m_session[i].alive == 0) continue;
		if(sa->sin_addr.S_un.S_addr != m_session[i].sa.sin_addr.S_un.S_addr) continue;
		if(sid != m_session[i].sid) continue;
		return i;
	}
	return -1;
}

int CSessionManager::AddSession(const SOCKADDR_IN *sa, int sid)
{
	int maxsessions = m_maxsessions;
	for(int i=0; i<maxsessions; ++i)
	{
		if(m_session[i].alive) continue;
		m_session[i].sa = *sa;
		m_session[i].sid = sid;
		m_session[i].alive = m_maxalive;
		return i;
	}
	return -1;
}

int CSessionManager::DelSession(int id)
{
	if(IsVaildSession(id) == false) return -1;
	m_session[id].alive = 0;
	return 0;
}

int CSessionManager::GetSessionSa(SOCKADDR_IN *sa, int id)
{
	if(IsVaildSession(id) == false) return -1;
	*sa = m_session[id].sa;
	return 0;
}

int CSessionManager::GetSessionSid(int id)
{
	if(IsVaildSession(id) == false) return -1;
	return m_session[id].sid;
}


int CSessionManager::GetSessionTimer(int id)
{
	if(IsVaildSession(id) == false) return -1;
	return m_session[id].alive;
}

int CSessionManager::DecSessionTimer()
{
	int maxsessions = m_maxsessions;
	for(int i=0; i<maxsessions; ++i){
		if(m_session[i].alive)
			--m_session[i].alive;
	}
	return 0;
}

int CSessionManager::ResetSessionTimer(int id)
{
	if(IsVaildSession(id) == false)
		return -1;
	m_session[id].alive = m_maxalive;
	return 0;
}
