#include "stdafx.h"

#include "winsock.h"
#include "CUdpSocket.h"

int CUdpSocket::Close()
{
	if(m_soc != INVALID_SOCKET)
	{
		closesocket(m_soc);
	}
	return 0;
}

int CUdpSocket::Open(HWND hWnd, UINT msg, int port)
{
	Close();

	if((m_soc = socket(AF_INET, SOCK_DGRAM, 0)) == INVALID_SOCKET)
		return -1;

	SOCKADDR_IN saLocal;
	saLocal.sin_addr.S_un.S_addr = 0;
	saLocal.sin_family = AF_INET;
	saLocal.sin_port = htons(port); // PORT
	if(bind(m_soc, (sockaddr*) &saLocal, sizeof(sockaddr)) == SOCKET_ERROR) {
		closesocket(m_soc);
		return -2;
	}
	WSAAsyncSelect(m_soc, hWnd, msg, FD_READ);
	return 0;
}

int CUdpSocket::SendTo(void *data, int sz, SOCKADDR_IN *to)
{
	if(m_soc != INVALID_SOCKET)
		return sendto(m_soc, (char*) data, sz, 0,(sockaddr*) to, sizeof(sockaddr));
	return SOCKET_ERROR;
}

int CUdpSocket::RecvFrom(void *data, int sz, SOCKADDR_IN *from)
{
	int fromlen = sizeof(sockaddr);
	if(m_soc != INVALID_SOCKET)
		return recvfrom(m_soc, (char*) data, sz, 0, (sockaddr*) from, &fromlen);
	return SOCKET_ERROR;
}