
#include "stdafx.h"

#include "defines.h"
#include "resource.h"

#include "CInifile.h"

#include "CUdpSocket.h"
#include "CSessionManager.h"
#include "CMyServerClient.h"

#include "CWaveIO.h"
#include "CImaAdpcm.h"

LRESULT WINAPI WorkerThread(LPVOID lpInstance);
HWND volatile hWndApp = NULL;
HWND volatile hWndWorker = NULL;
HANDLE volatile hWorkerInited;


LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK ConProc(HWND, UINT, WPARAM, LPARAM);

#define WINDOWCLASSNAME TEXT("tsuAppDialog")

SOCKETPARAM g_socketparam;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPTSTR lpCmdLine, int nCmdShow)
{
	SetPriorityClass(GetCurrentProcess(), HIGH_PRIORITY_CLASS);

	{ // RegisterClass
		WNDCLASSEX wcex;

		wcex.cbSize = sizeof(WNDCLASSEX); 

		wcex.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
		wcex.lpfnWndProc	= (WNDPROC)WndProc;
		wcex.cbClsExtra		= 0;
		wcex.cbWndExtra		= DLGWINDOWEXTRA;
		wcex.hInstance		= hInstance;
		wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_APPICON);
		wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wcex.hbrBackground	= CreateSolidBrush(GetSysColor(COLOR_MENU));
		wcex.lpszMenuName	= (LPCTSTR) IDR_APPMAIN;
		wcex.lpszClassName	= WINDOWCLASSNAME;
		wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_APPICON);

		if(!RegisterClassEx(&wcex)) return -1;
	}

	{ // Init Instance
#ifndef SERVERONLY
		HWND hWnd = hWndApp = CreateDialog(hInstance, (LPCTSTR) IDD_APPMAIN, NULL, (DLGPROC) WndProc);
#else
		HWND hWnd = hWndApp = CreateDialog(hInstance, (LPCTSTR) IDD_APPMAIN1, NULL, (DLGPROC) WndProc);
#endif
		if (!hWnd) return -2;
		ShowWindow(hWnd, nCmdShow);
		UpdateWindow(hWnd);
	}

	MSG msg;
	HACCEL hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDR_APPACCELERATOR);
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return (int) msg.wParam;
}


LRESULT CALLBACK WndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	static DWORD dwWorker;
	static HANDLE hWorker;
	static CInifile ini;

	switch(Msg)
	{
	case WM_CREATE:
		InitCommonControls();

		SetWindowText(hWnd, APPTITLE );
		{
			TCHAR fn[MAX_PATH];
			GetModuleFileName(NULL, fn, MAX_PATH);
			char *p = _tcsrchr(fn, '.');
			if(p!=NULL) *p = '\0';
			_tcsncat(fn, TEXT(".ini"), MAX_PATH);
			ini.Open(fn, TEXT("hanasu"));
		}

		{
			RECT rect;
			GetWindowRect(hWnd, &rect);
			MoveWindow(hWnd,
				ini.LoadInt(TEXT("Left"), 0),ini.LoadInt(TEXT("Top"), 0),
				rect.right-rect.left, rect.bottom-rect.top, TRUE);
		}

		PostMessage(hWnd, WM_INITIALIZE, 0,0);
		PostMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_CONNECT, 0), 0);
		break;

	case WM_INITIALIZE:
		{
			for(int i=0; i<MAXCLIENTS; ++i)
				SendDlgItemMessage(hWnd, IDC_VOL1 + i, PBM_SETRANGE, 0, MAKELPARAM(0, 96));
			SendDlgItemMessage(hWnd, IDC_VOLSEND, PBM_SETRANGE, 0, MAKELPARAM(0, 96));
//			SendDlgItemMessage(hWnd, IDC_VOLRECV, PBM_SETRANGE, 0, MAKELPARAM(0, 96));
		}

		hWorkerInited = CreateEvent(NULL, TRUE, FALSE, NULL);
		hWorker = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) WorkerThread,(LPVOID) NULL, 0, &dwWorker);
		WaitForSingleObject(hWorkerInited, -1);
		while(PostMessage( hWndWorker, Msg, wParam , lParam) == FALSE)
			Sleep(0);
		break;

	case WM_DESTROY:
		{
			RECT rect;
			GetWindowRect(hWnd, &rect);
			ini.SaveInt(TEXT("Left"), rect.left);
			ini.SaveInt(TEXT("Top"), rect.top);
		}

		PostMessage( hWndWorker, Msg, wParam, lParam);
		PostQuitMessage(0);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_CONNECT:

			ZeroMemory(&g_socketparam, sizeof(g_socketparam));
#ifndef SERVERONLY
			{ // READ g_socketparam
				ini.LoadStr(TEXT("NickName"), g_socketparam.UserName,
					sizeof(g_socketparam.UserName)/sizeof(g_socketparam.UserName[0]), TEXT("unnamed"));
				ini.LoadStr(TEXT("RemoteHost"), g_socketparam.RemoteHost,
					sizeof(g_socketparam.RemoteHost)/sizeof(g_socketparam.RemoteHost[0]), TEXT(""));
				g_socketparam.RemotePort = ini.LoadInt(TEXT("RemotePort"),9876);
				g_socketparam.ServerMode = ini.LoadInt(TEXT("ServerMode"),1);
				g_socketparam.LocalPort = ini.LoadInt(TEXT("LocalPort"),0);
			}
			if(DialogBox(GetModuleHandle(NULL), (LPSTR) IDD_CONNECT, hWnd, (DLGPROC) ConProc) == IDOK)
			{ // WRITE g_socketparam
				ini.SaveStr(TEXT("NickName"), g_socketparam.UserName);
				ini.SaveStr(TEXT("RemoteHost"), g_socketparam.RemoteHost);
				ini.SaveInt(TEXT("LocalPort"), g_socketparam.LocalPort);
				ini.SaveInt(TEXT("ServerMode"), g_socketparam.ServerMode);
				PostMessage(hWndWorker, WM_CONNECT, 0, (LPARAM) &g_socketparam);
			}
			break;
#else
			{ // READ g_socketparam
				strcpy(g_socketparam.RemoteHost, "localhost");
				g_socketparam.UserName[0] = '\0';
				g_socketparam.ServerMode = 1;
				g_socketparam.RemotePort = ini.LoadInt(TEXT("RemotePort"),9876);
			}
			if(DialogBox(GetModuleHandle(NULL), (LPSTR) IDD_CONNECT1, hWnd, (DLGPROC) ConProc) == IDOK)
			{ // WRITE g_socketparam
				ini.SaveInt(TEXT("RemotePort"), g_socketparam.RemotePort);
				PostMessage(hWndWorker, WM_CONNECT, 0, (LPARAM) &g_socketparam);
			}
			break;
#endif

		case IDC_MUTERECV: case IDC_MUTESEND:
			PostMessage(hWndWorker, WM_COMMAND, SETMUTE, 
				MAKELPARAM(LOWORD(wParam) - IDC_MUTERECV, SendDlgItemMessage(hWnd, LOWORD(wParam), BM_GETCHECK, 0, 0) ) );
			break;

		case IDC_MUTE1: case IDC_MUTE2: case IDC_MUTE3: case IDC_MUTE4:
		case IDC_MUTE5: case IDC_MUTE6: case IDC_MUTE7: case IDC_MUTE8:
		case IDC_MUTE9: case IDC_MUTE10:case IDC_MUTE11:case IDC_MUTE12:
		case IDC_MUTE13:case IDC_MUTE14:case IDC_MUTE15:case IDC_MUTE16:
			PostMessage(hWndWorker, WM_COMMAND, SETMUTE2, 
				MAKELPARAM(LOWORD(wParam) - IDC_MUTE1, SendDlgItemMessage(hWnd, LOWORD(wParam), BM_GETCHECK, 0, 0) ) );
			break;

		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;

		default:
			DefWindowProc(hWnd, Msg, wParam, lParam);
		}
		break;

	default:
		return DefWindowProc(hWnd, Msg, wParam, lParam);

	}
	return 0;
}

INT_PTR CALLBACK ConProc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static SOCKETPARAM temp;

	switch(msg)
	{
	case WM_INITDIALOG:
		SetDlgItemText(hDlg, IDC_NAME, g_socketparam.UserName);
		SendDlgItemMessage(hDlg, IDC_NAME, EM_LIMITTEXT, MAXUSERNAMELEN-1, 0);

		SetDlgItemTextA(hDlg, IDC_REMOTEHOST, g_socketparam.RemoteHost);
		SendDlgItemMessage(hDlg, IDC_REMOTEHOST, EM_LIMITTEXT, sizeof(g_socketparam.RemoteHost)-1, 0);

		SetDlgItemInt(hDlg, IDC_REMOTEPORT, g_socketparam.RemotePort, FALSE);

		if(g_socketparam.LocalPort)
		{
			SendDlgItemMessage(hDlg, IDC_PORTFIX, BM_SETCHECK, TRUE, 0);
			EnableWindow(GetDlgItem(hDlg, IDC_LOCALPORT), TRUE);
			SetDlgItemInt(hDlg, IDC_LOCALPORT, g_socketparam.LocalPort, FALSE);
		}

		if(g_socketparam.ServerMode)
		{
			SendDlgItemMessage(hDlg, IDC_SERVERMODE, BM_SETCHECK, g_socketparam.ServerMode, 0);
			EnableWindow(GetDlgItem(hDlg, IDC_REMOTEHOST), FALSE);
		}

#ifdef SERVERONLY
		EnableWindow(GetDlgItem(hDlg, IDCANCEL), FALSE);
#endif

		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_SERVERMODE:
			if(SendDlgItemMessage(hDlg, IDC_SERVERMODE, BM_GETCHECK, 0, 0))
			{
				GetDlgItemTextA(hDlg, IDC_REMOTEHOST, temp.RemoteHost, sizeof(temp.RemoteHost)/sizeof(temp.RemoteHost[0]));
				SetDlgItemTextA(hDlg, IDC_REMOTEHOST, "127.0.0.1" );
				EnableWindow(GetDlgItem(hDlg, IDC_REMOTEHOST), FALSE);
			}
			else
			{
				SetDlgItemTextA(hDlg, IDC_REMOTEHOST, temp.RemoteHost);
				EnableWindow(GetDlgItem(hDlg, IDC_REMOTEHOST), TRUE);
			}
			return TRUE;

		case IDC_PORTFIX:
			if(SendDlgItemMessage(hDlg, IDC_PORTFIX, BM_GETCHECK, 0, 0))
			{
				SetDlgItemInt(hDlg, IDC_LOCALPORT, temp.LocalPort, FALSE);
				if(temp.LocalPort == 0)
					SetDlgItemInt(hDlg, IDC_LOCALPORT, g_socketparam.RemotePort, FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_LOCALPORT), TRUE);
			}
			else
			{
				temp.LocalPort = GetDlgItemInt(hDlg, IDC_LOCALPORT, NULL, FALSE);
				EnableWindow(GetDlgItem(hDlg, IDC_LOCALPORT), FALSE);
			}
			return TRUE;

		case IDOK:
			{
				BOOL bTranslated = TRUE;
				GetDlgItemText(hDlg, IDC_NAME, temp.UserName, sizeof(temp.UserName)/sizeof(temp.UserName[0]) );

				GetDlgItemTextA(hDlg, IDC_REMOTEHOST, temp.RemoteHost, sizeof(temp.RemoteHost)/sizeof(temp.RemoteHost[0]));

				temp.RemotePort = GetDlgItemInt(hDlg, IDC_REMOTEPORT, &bTranslated, FALSE);
				if(!bTranslated || !temp.RemotePort || temp.RemotePort>65535)
				{
					MessageBox(hDlg, TEXT("T[õ|[gρH\n 1-65535Ŏw"), TEXT("H"), MB_OK|MB_ICONEXCLAMATION);
					return TRUE;
				}

				temp.LocalPort = SendDlgItemMessage(hDlg, IDC_PORTFIX, BM_GETCHECK, 0, 0)
					? GetDlgItemInt(hDlg, IDC_LOCALPORT, &bTranslated, FALSE) : 0;
				if(!bTranslated || temp.LocalPort>65535)
				{
					MessageBox(hDlg, TEXT("[J|[gρH\n 1-65535Ŏw"), TEXT("H"), MB_OK|MB_ICONEXCLAMATION);
					return TRUE;
				}

				temp.ServerMode = (int) SendDlgItemMessage(hDlg, IDC_SERVERMODE, BM_GETCHECK, 0, 0);

				g_socketparam = temp;
				EndDialog(hDlg, IDOK);
			}
			return TRUE;

		case IDCANCEL:
			EndDialog(hDlg, IDCANCEL);
			return TRUE;
		}
		return FALSE;
	}
	return FALSE;
}

#define WORKERWNDCLASSNAME TEXT("VCHATWORKERWINDOW")
LRESULT CALLBACK MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

LRESULT WINAPI WorkerThread(LPVOID )
{
	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);

	HINSTANCE hInstance = GetModuleHandle(NULL);

	{ // RegisterClass
		WNDCLASSEX wcex;

		wcex.cbSize = sizeof(WNDCLASSEX); 

		wcex.style			= 0;
		wcex.lpfnWndProc	= (WNDPROC) MsgProc;
		wcex.cbClsExtra		= 0;
		wcex.cbWndExtra		= 0;
		wcex.hInstance		= hInstance;
		wcex.hIcon			= NULL;
		wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wcex.hbrBackground	= (HBRUSH) GetStockObject(NULL_BRUSH);
		wcex.lpszMenuName	= NULL;
		wcex.lpszClassName	= WORKERWNDCLASSNAME;
		wcex.hIconSm		= NULL;

		if(!RegisterClassEx(&wcex)) return -1;
	}

	HWND hWnd = hWndWorker = CreateWindow(
		WORKERWNDCLASSNAME, WORKERWNDCLASSNAME, 0,
		0, 0, 0, 0,
		NULL, NULL, hInstance, NULL);

	if(hWnd == NULL)
	{
		MessageBox(hWndApp, TEXT("[J[Xbh̏Ɏs܂"), TEXT("Ȃ܂"), MB_ICONERROR);
		ExitProcess(0);
	}
	

	SetEvent(hWorkerInited);

	MSG Msg;
	while(GetMessage(&Msg, NULL, 0, 0))
	{
		TranslateMessage(&Msg);
		DispatchMessage(&Msg);
	}

	return Msg.wParam;
}

WAVEFORMATEX createwfx(int ch, int freq, int bps)
{
	WAVEFORMATEX wfx = { WAVE_FORMAT_PCM, ch,freq,ch*bps*freq/8,ch*bps/8,bps,0 };
	return wfx;
}

int getsabyname(SOCKADDR_IN* sa, char* hostname, int port)
{
	ZeroMemory(sa, sizeof(SOCKADDR_IN));
	sa->sin_family = AF_INET;
	if((signed)(sa->sin_addr.S_un.S_addr = inet_addr(hostname)) == SOCKET_ERROR)
	{
		HOSTENT* h = gethostbyname(hostname);
		if(h == NULL){
			return SOCKET_ERROR;
		}
		sa->sin_addr.S_un.S_addr = *((unsigned long*) (h->h_addr));
	}
	sa->sin_port = htons(port);
	return 0;
}


LRESULT CALLBACK MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	MMRESULT mr;
	TCHAR mrErrStr[MAXERRORLENGTH];

#ifndef SERVERONLY
	static CWaveIn<32, PCMBUFFERLEN> wavein;
#endif

	static CWaveOut<8, PCMBUFFERLEN> waveout[MAXCLIENTS];

#ifndef SERVERONLY
	static CMyClient client(5);
#endif

	static CMyServer server(MAXCLIENTS,3);
	static SOCKETPARAM sockparam;

	static TCHAR clientNames[MAXCLIENTS][MAXUSERNAMELEN] = { 0 };

	static CImaAdpcm iaClient;

	static int Mutesw[2] = {0, 0} ;
	static int Mutesw2[MAXCLIENTS] = {0};

	switch(msg)
	{

	case WM_INITIALIZE:
		{ // socket init
			WSADATA wsadata;
			WSAStartup(MAKEWORD(2,0), &wsadata);
		}
		{ // wave io init;
			WAVEFORMATEX wfx = createwfx(1, 8000, 16);

#ifndef SERVERONLY
			mr = wavein.Open(hWnd, &wfx);
			if(mr){
				waveInGetErrorText( mr, mrErrStr, sizeof(mrErrStr) );
				MessageBox(hWndApp, mrErrStr, TEXT("Error: I[fBI̓foCXJ܂B"), MB_OK|MB_ICONWARNING);
				ExitProcess(0);
			}
#endif
			for(int i=0; i<MAXCLIENTS; ++i)
			{
				mr = waveout[i].Open(hWnd, &wfx);
				if(mr){
					waveOutGetErrorText( mr, mrErrStr, sizeof(mrErrStr) );
					MessageBox(hWndApp, mrErrStr, TEXT("Error: I[fBIo̓foCXJ܂B"),MB_OK|MB_ICONWARNING);
					ExitProcess(0);
				}
			}
		}

		CImaAdpcm::Init();
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case SETMUTE:
			Mutesw[LOWORD(lParam)] = HIWORD(lParam);
			break;
		case SETMUTE2:
			Mutesw2[LOWORD(lParam)] = HIWORD(lParam);
		}
		break;

	case WM_DESTROY:

#ifndef SERVERONLY
		client.SendPakcet( MAKEMSG(CSM_QUNACTIVATE,0,0,0), NULL, 0);
		client.Close();
		wavein.Close();

		KillTimer(hWnd, CLI_SECTIMER);
#endif

		for(int i=0;i<MAXCLIENTS; ++i)
			waveout[i].Close();

		server.Close();
		KillTimer(hWnd, SRV_SECTIMER);

		WSACleanup();
		SetTimer(hWnd, EXIT, 3000, NULL);
		break;

#ifndef SERVERONLY
	case MM_WIM_DATA:
		{
			IMAADPCMBLOCK imablock;
			LPWAVEHDR pwh = (LPWAVEHDR) lParam;

			if(pwh->dwBytesRecorded == PCMBUFFERLEN)
			{
				iaClient.Enc( &imablock, (short*) pwh->lpData, SAMPLESPERPACKET, 0);
				if(Mutesw[1]) {
					ZeroMemory(pwh->lpData, PCMBUFFERLEN);
					iaClient.Reset();
					iaClient.Enc( &imablock, (short*) pwh->lpData, SAMPLESPERPACKET, 0);
				}
				SendDlgItemMessage(hWndApp, IDC_VOLSEND, PBM_SETPOS, imablock.maxvol, 0);
				client.SendPakcet(MAKEMSG(CSM_DATA,0,0,0), &imablock, sizeof(imablock));
			}
			wavein.OnData(wParam,lParam);
		}
		break;
#endif

	case MM_WOM_DONE:
		waveout[0].OnDone(wParam,lParam);
		break;

	case WM_CONNECT:
		{
			SetWindowText(hWndApp, APPTITLE TEXT("- ڑ..."));
			for(int i=0;i<MAXCLIENTS; ++i)
			{
				SendDlgItemMessage(hWndApp, IDC_VOL1+i, PBM_SETPOS, 0, 0);
				SetWindowText(GetDlgItem(hWndApp, IDC_NAME1+i), TEXT(""));
			}
			SendDlgItemMessage(hWndApp, IDC_VOLSEND, PBM_SETPOS, 0, 0);
			// SendDlgItemMessage(hWndApp, IDC_VOLRECV, PBM_SETPOS, 0, 0);


			sockparam = *(SOCKETPARAM*)lParam;
			server.Close();

			if(sockparam.ServerMode)
			{
				if( server.Open(hWnd, WM_SVSOCK, sockparam.RemotePort) < 0){
					SetWindowText(hWndApp, APPTITLE TEXT("- ؒf"));
					MessageBox(hWndApp, TEXT("T[o\Pbg̍쐬Ɏs܂B"), TEXT("|[ggĂȂH"), MB_OK | MB_ICONWARNING);
					break;
				}
			}

#ifndef SERVERONLY
			SOCKADDR_IN saServer;
			if(getsabyname(&saServer, sockparam.RemoteHost, sockparam.RemotePort) < 0){
				SetWindowText(hWndApp, APPTITLE TEXT("- ؒf"));
				MessageBox(hWndApp, TEXT("zXgɎs܂B"),TEXT("ƍĂH"), MB_OK | MB_ICONWARNING);
				break;
			}
			client.SendPakcet( MAKEMSG(CSM_QUNACTIVATE,0,0,0), NULL, 0);
			client.DelSession();
			if(client.AddSession(&saServer, GetTickCount() ) < 0){
				SetWindowText(hWndApp, APPTITLE TEXT("- ؒf"));
				MessageBox(hWndApp, TEXT("code:client.AddSession()"),TEXT("\ʃG[܂B"), MB_OK | MB_ICONWARNING);
				break;
			}

			if(client.Open(hWnd, WM_SOCK, sockparam.LocalPort) < 0){
				SetWindowText(hWndApp, APPTITLE TEXT("- ؒf"));
				MessageBox(hWndApp, TEXT("NCAg\Pbg̍쐬Ɏs܂B"),TEXT("T[o|[gƈꏏɂȂĂȂH"), MB_OK | MB_ICONWARNING);
				break;
			}

			client.SendPakcet( MAKEMSG(CSM_QACTIVATE,0,0,0), sockparam.UserName, sizeof(sockparam.UserName));

			SetTimer(hWnd, CLI_SECTIMER, 1000, NULL);
			SetTimer(hWnd, CSM_QACTIVATE, 2000, NULL);
#endif
			if(sockparam.ServerMode)
			{
				SetTimer(hWnd, SRV_SECTIMER, 1000, NULL);
				SetWindowText(hWndApp, APPTITLE TEXT("- T[oғ"));
			}
		}
		break;

#ifndef SERVERONLY
	case WM_SOCK:
		if(WSAGETSELECTERROR(lParam) != 0) {
			OutputDebugString(TEXT("client \PbgG[\n"));
			break;
		}
		if (WSAGETSELECTEVENT(lParam) != FD_READ) break;

		{
			PACKET pkt;
			int sz = client.RecvPacket(&pkt);
			if (sz < 0){
				switch (sz){
					case -1:OutputDebugString(TEXT("client Recvs\n")); break;
					case -2:OutputDebugString(TEXT("client S~pktM\n")); break;
				}
				break;
			}

			client.ResetSessionTimer();

			int fromid = MSGP1(pkt.hdr.msg);
			if(fromid<0 || fromid>=MAXCLIENTS)
			{
				OutputDebugString(TEXT("client fromidُpktM\n")); 
				break;
			}


			switch(MSGTYPE(pkt.hdr.msg)) // Client SocketProc
			{
			case SCM_DATA:
				{
					short wv[SAMPLESPERPACKET];
					IMAADPCMBLOCK *pima = (IMAADPCMBLOCK*) pkt.data;
					iaClient.Dec(wv, SAMPLESPERPACKET, pima);
					if(!Mutesw[0] && !Mutesw2[fromid]) waveout[fromid].Write(wv, SAMPLESPERPACKET*2);
					
					SendDlgItemMessage(hWndApp, IDC_VOL1 + fromid, PBM_SETPOS, pima->maxvol , 0);
				}
				break;

			case SCM_RACTIVATE:
				SetWindowText(hWndApp, APPTITLE TEXT("- ڑ"));
				KillTimer(hWnd, CSM_QACTIVATE);
				if(fromid == 255){
					client.Close();
					SetWindowText(hWndApp, APPTITLE TEXT("- ؒf"));
					MessageBox(hWndApp, TEXT("T[oɒe܂B"), TEXT("H"), MB_OK|MB_ICONWARNING);
					break;
				}
				for(int i=0; i<MAXCLIENTS; ++i){
					SetWindowText(GetDlgItem(hWndApp, IDC_NAME1+i), pkt.data + MAXUSERNAMELEN*i );
				}

				iaClient.Reset();
				wavein.Start();
				break;

			case SCM_RUSERLIST:
				KillTimer(hWnd, CSM_QUSERLIST);
				for(int i=0; i<MAXCLIENTS; ++i){
					SetWindowText(GetDlgItem(hWndApp, IDC_NAME1+i), pkt.data + MAXUSERNAMELEN*i);
				}
				break;

			case SCM_NACTIVATE:
				SetWindowText(GetDlgItem(hWndApp, IDC_NAME1 + fromid), pkt.data);
				break;

			case SCM_NUNACTIVATE:
				SetWindowText(GetDlgItem(hWndApp, IDC_NAME1 + fromid), TEXT("") );
				break;
			}
		}
		break;
#endif

	case WM_SVSOCK:
		if(WSAGETSELECTERROR(lParam) != 0){
			OutputDebugString("server \PbgG[\n");
			break;
		}

		if (WSAGETSELECTEVENT(lParam) != FD_READ) break;

		{
			PACKET pkt;
			SOCKADDR_IN saFrom;
			int sz = server.RecvPacketFrom(&pkt, &saFrom);
			if (sz < 0) {
				switch (sz){
					case -1:OutputDebugString("Server Recvs\n"); break;
					case -2:OutputDebugString("Server S~pktMH\n"); break;
				}
				break;
			}
			int fromid = server.GetSessionId( &saFrom, pkt.hdr.sid);
			if( fromid < 0 && pkt.hdr.msg != CSM_QACTIVATE)
				break;

			server.ResetSessionTimer(fromid);

			switch(MSGTYPE(pkt.hdr.msg)) // Server SocketProc
			{
			case CSM_DATA:
#ifdef SERVERONLY
				{
					short wv[SAMPLESPERPACKET];
					IMAADPCMBLOCK *pima = (IMAADPCMBLOCK*) pkt.data;
					iaClient.Dec(wv, SAMPLESPERPACKET, pima);
					if(!Mutesw[0] && !Mutesw2[fromid]) waveout[fromid].Write(wv, SAMPLESPERPACKET*2);
					
					SendDlgItemMessage(hWndApp, IDC_VOL1 + fromid, PBM_SETPOS, pima->maxvol , 0);
				}
#endif

				server.BroadCastPacket( MAKEMSG(SCM_DATA, fromid ,0,0 ), pkt.data, sizeof(IMAADPCMBLOCK) );
				break;

			case CSM_QNULL:
				server.SendPacketTo(fromid, MAKEMSG(SCM_RNULL, fromid ,0,0), NULL, 0);
				break;

			case CSM_QUSERLIST:
				server.SendPacketTo(fromid, MAKEMSG(SCM_RACTIVATE, fromid ,0,0), clientNames, sizeof(clientNames));
				break;

			case CSM_QACTIVATE:
				if(fromid < 0){
					fromid = server.AddSession(&saFrom, pkt.hdr.sid);
					if(fromid < 0) {
						server.SendPacketTo(&saFrom, pkt.hdr.sid,  MAKEMSG(SCM_RACTIVATE, 255,0,0), NULL, 0);
						break;
					}
					memcpy(clientNames[fromid], pkt.data, MAXUSERNAMELEN);
					server.BroadCastPacket(MAKEMSG(SCM_NACTIVATE, fromid ,0,0), pkt.data, MAXUSERNAMELEN );
					server.SendPacketTo(fromid, MAKEMSG(SCM_RACTIVATE, fromid ,0,0), clientNames, sizeof(clientNames));
				}
#ifdef SERVERONLY
				SetWindowText(GetDlgItem(hWndApp, IDC_NAME1 + fromid), pkt.data);
#endif
				break;


			case CSM_QUNACTIVATE:
				clientNames[fromid][0] = '\0';
				server.DelSession(fromid);
				server.BroadCastPacket(MAKEMSG(SCM_NUNACTIVATE, fromid ,0,0), pkt.data, sz);
#ifdef SERVERONLY
				SetWindowText(GetDlgItem(hWndApp, IDC_NAME1 + fromid), TEXT("") );
#endif
				break;
			}
		}
		break;

	case WM_TIMER:
		switch(wParam)
		{
#ifndef SERVERONLY
		case CSM_QACTIVATE:
			client.SendPakcet( MAKEMSG(CSM_QACTIVATE,0,0,0), sockparam.UserName, sizeof(sockparam.UserName));
			break;
		case CSM_QUSERLIST:
			client.SendPakcet( MAKEMSG(CSM_QUSERLIST,0,0,0), NULL, 0);
			break;
		case CLI_SECTIMER:
			client.SendPakcet( MAKEMSG(CSM_QNULL,0,0,0), NULL, 0);
			client.DecSessionTimer();
 			if(!client.IsVaildSession())
			{
				// ؒf
				client.Close();
				server.Close();

				wavein.Stop();
				KillTimer(hWnd, CLI_SECTIMER);
				SetWindowText(hWndApp, APPTITLE TEXT("- ؒf"));

				MessageBox(hWndApp, TEXT("΂񂵂܂B"), TEXT("邦"), MB_OK|MB_ICONWARNING);
			}
			break;
#endif

		case SRV_SECTIMER:
			{
				bool prevstat[MAXCLIENTS];
				for(int i=0;i<MAXCLIENTS;i++)
					prevstat[i] = server.IsVaildSession(i);
				server.DecSessionTimer();
				for(int i=0; i<MAXCLIENTS; i++)
				{
					if(prevstat[i] && !server.IsVaildSession(i))
					{
						// ؒf
						clientNames[i][0] = '\0';
						server.BroadCastPacket(MAKEMSG(SCM_NUNACTIVATE, i, 0, 0), NULL, 0);
#ifdef SERVERONLY
						SetWindowText(GetDlgItem(hWndApp, IDC_NAME1 + i), TEXT("") );
#endif
					}
				}
			}
			break;

		case EXIT:
			MessageBox(NULL,TEXT("vO~O蕳ł߂Ȃorz"),TEXT(""),MB_OK|MB_ICONERROR);
			ExitProcess(0);
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd, msg, wParam, lParam);
	}
	return 0;
}
